#guard MessageEngine

#if timeout_included
    setdef uses_TimeOut = ,TimeOut
#endif

#if gamedata_included
    setdef uses_GameData = ,GameData
#endif

namespace MessageEngine using General uses_TimeOut uses_GameData

#if gamedata_included
    void DisplayToAll(string msg){
        int i = 0;
        loop{
            if i:user.flag {
                call DisplayTimedTextToPlayer( i:user.player, 0., 0., default_ls_common, msg );
            };
            i++;
            exif( i == ( PLAYER_NEUTRAL_PASSIVE +1 ) );
        };
    };

    class msgine {
        string     message     = nil;
        int         pid         = no_data;
        countdown   clock       = no_data;
        float       lifespan    = default_lifespan

        destructor(){
            message = nil;
            clock.destroy();
            free self
        }

        __callback callback(){
            local self = countdown.expiredof(1)
            if this.pid > (no_data) { DisplayTimedTextToPlayer( user[this.pid].player, 0., 0., this.lifespan, this.message )} else {
                DisplayToAll(this.message);
            };
            if this.clock.autoLiquidation {
                this.destroy();
            };
        }

        void print(){ DisplayToAll(this.message) }
        void printlag(float time){ this.clock.push(-time, __api itself.callback ) };
        void printtoplayer(gamedata whom){ DisplayTimedTextToPlayer( whom.player, 0., 0., this.lifespan, this.message ) };
        void printlagtoplayer(float time, gamedata whom){ this.pid = whom.id; this.clock.push(-time, __api itself.callback ) };
        void add(string text, bool newLine){ if newLine { this.message = this.message + "\n"}; this.message += text };

        constructor(bool autoDestructible) {
            new self;
            this.clock = countdown.create(autoDestructible);
            this.clock.putdata(1,this)
            this.message = "\n";
            return this
        };
    }
#endif

endnamespace