#guard sysspell_j

#define spellsystem_included = true



setdef uses_SSpell = ,SpellSystem 

enum (ssregix) { ssr_all, ssr_cast, ssr_learn };

namespace SpellSystem using General uses_Pawls

    private pawl        pwHeroSkill 	= no_data;
	private pawl 		pwHeroCast 		= no_data;
	private hashtable	tysch			= InitHashtable();

            int         ss_SKILL_ID         = 0x0;
            int         ss_CAST_ID          = 0x0;
            int         ss_CAST_LEVEL       = 0x0;

    const   int         const_push_func     = StringHash("push-func")
    const   int         const_push_func_ex  = StringHash("push-func-ex")

	private void skillHeroes(){
		int 	sid     = OBJECT_SKILL_ID;
        string  sfunc   = LoadStr( tysch, sid, const_push_func_ex )

        ss_SKILL_ID = sid;

        if sfunc != nil {
            ExecuteFunc(sfunc);
        };
		
	}


	private void castHeroes(){
		int 	cid 	= OBJECT_CAST_ID;
        string  cfunc   = LoadStr( tysch, cid, const_push_func )

        ss_CAST_ID = cid;
        ss_CAST_LEVEL = GetUnitAbilityLevel( GetSpellAbilityUnit(), cid );

        if cfunc != nil {
            ExecuteFunc(cfunc);
        };

	}

    void RegisterSpell( int spellId, string funcName, int sstRegistration ){
        if ( sstRegistration == ssr_all ) {
            SaveStr( tysch, spellId, const_push_func, funcName );
            SaveStr( tysch, spellId, const_push_func_ex, "sk_" + funcName );
        } else {
        if (sstRegistration == ssr_cast ) {SaveStr( tysch, spellId, const_push_func, funcName )};
            if (sstRegistration == ssr_learn ) {SaveStr( tysch, spellId, const_push_func_ex, funcName )};
        };
        
    }

	void SpellSystemRegister( object ho, bool learnSkillToo ){

		if learnSkillToo {
			if pwHeroSkill == no_data {
				pwHeroSkill = pawl.create(true,true);
				pwHeroSkill.action( __api skillHeroes );
			}

			pwHeroSkill.eventObject( ho, EVENT_OBJ_SKILL );
		}

		if pwHeroCast == no_data {
			pwHeroCast = pawl.create(true,true);
			pwHeroCast.action( __api castHeroes );
		}

		pwHeroCast.eventObject( ho, EVENT_OBJ_CAST );

	}

    endnamespace